# generated by eelbrain/scripts/make_example_tests.py
import logging
import os
import re
import shutil
from tempfile import mkdtemp

from matplotlib import pyplot as plt

from eelbrain.lab import plot

dir_ = os.path.dirname(__file__)
examples_dir = os.path.join(dir_, '..', '..', 'examples')
examples_dir = os.path.abspath(examples_dir)


def test_0():
    "Test datasets/align.py"
    exa_dir = os.path.join(examples_dir, 'datasets')
    exa_file = os.path.join(exa_dir, 'align.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['align.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('align.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_1():
    "Test fmtxt/report.py"
    exa_dir = os.path.join(examples_dir, 'fmtxt')
    exa_file = os.path.join(exa_dir, 'report.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['report.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('report.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_2():
    "Test fmtxt/table.py"
    exa_dir = os.path.join(examples_dir, 'fmtxt')
    exa_file = os.path.join(exa_dir, 'table.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['table.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('table.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_3():
    "Test fmtxt/table_pdf.py"
    exa_dir = os.path.join(examples_dir, 'fmtxt')
    exa_file = os.path.join(exa_dir, 'table_pdf.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['table_pdf.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('table_pdf.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_4():
    "Test meg/mne_sample_loader.py"
    exa_dir = os.path.join(examples_dir, 'meg')
    exa_file = os.path.join(exa_dir, 'mne_sample_loader.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['mne_sample_loader.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('mne_sample_loader.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_5():
    "Test meg/simple meg.py"
    exa_dir = os.path.join(examples_dir, 'meg')
    exa_file = os.path.join(exa_dir, 'simple meg.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['simple meg.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('simple meg.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_6():
    "Test ndvar/topo.py"
    exa_dir = os.path.join(examples_dir, 'ndvar')
    exa_file = os.path.join(exa_dir, 'topo.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['topo.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('topo.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_7():
    "Test ndvar/uts cluster permutation test.py"
    exa_dir = os.path.join(examples_dir, 'ndvar')
    exa_file = os.path.join(exa_dir, 'uts cluster permutation test.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['uts cluster permutation test.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('uts cluster permutation test.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_8():
    "Test ndvar/uts.py"
    exa_dir = os.path.join(examples_dir, 'ndvar')
    exa_file = os.path.join(exa_dir, 'uts.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['uts.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('uts.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_9():
    "Test statistics/ANCOVA_Crawley.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'ANCOVA_Crawley.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['ANCOVA_Crawley.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('ANCOVA_Crawley.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_10():
    "Test statistics/ANCOVA_rutherford.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'ANCOVA_rutherford.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['ANCOVA_rutherford.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('ANCOVA_rutherford.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_11():
    "Test statistics/ANOVA.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'ANOVA.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['ANOVA.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('ANOVA.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_12():
    "Test statistics/ANOVA_rutherford_1.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'ANOVA_rutherford_1.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['ANOVA_rutherford_1.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('ANOVA_rutherford_1.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_13():
    "Test statistics/ANOVA_rutherford_2.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'ANOVA_rutherford_2.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['ANOVA_rutherford_2.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('ANOVA_rutherford_2.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_14():
    "Test statistics/Fox_Prestige.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'Fox_Prestige.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['Fox_Prestige.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('Fox_Prestige.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_15():
    "Test statistics/pdf.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'pdf.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['pdf.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('pdf.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_16():
    "Test statistics/simple.py"
    exa_dir = os.path.join(examples_dir, 'statistics')
    exa_file = os.path.join(exa_dir, 'simple.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['simple.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('simple.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)

def test_17():
    "Test ui/progress_monitor.py"
    exa_dir = os.path.join(examples_dir, 'ui')
    exa_file = os.path.join(exa_dir, 'progress_monitor.py')

    # find required files
    with open(exa_file) as fid:
        text = fid.read()
    filenames = ['progress_monitor.py'] + re.findall("# requires: (\w+.\w+)", text)

    # copy all files to temporary dir
    tempdir = mkdtemp()
    for filename in filenames:
        src = os.path.join(exa_dir, filename)
        shutil.copy(src, tempdir)

    # execute example
    logging.info("executing from %s" % tempdir)
    os.chdir(tempdir)
    plot.configure_backend(False, False)
    execfile('progress_monitor.py', {})
    plt.close('all')

    # delete temporary files
    shutil.rmtree(tempdir)
